unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Properties1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Portsettings1: TMenuItem;
    Edit1: TEdit;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Button2: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Label2: TLabel;
    Button3: TButton;
    Exit1: TMenuItem;
    Label3: TLabel;
    Edit4: TEdit;
    Button4: TButton;
    Memo1: TMemo;
    Button5: TButton;
    Button6: TButton;
    Timer1: TTimer;
    Button7: TButton;
    CheckBox1: TCheckBox;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    procedure Exit1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  FileHandleA: Integer;       // File handle for the asm file
  FileHandleB: Integer;       // File handle for the bin file
  ByteBufArray: array[1..4096] of Byte;     // Tx buffer
  RxBuf: array[1..4096] of Byte;            // Rx buffer
  CharBuf: Char;
  OutBuf: array[1..8192] of Byte;   // Output binary buffer
  BytesToWrite: Integer;            // Number of binary bytes to write
  RetCode: Integer;           // General purpose variable to store return code
  i,j,k: Integer;             // General purpose integers
  ComFile: THandle;
  DCB: TDCB;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then exit;
  Edit1.Text := OpenDialog1.FileName;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  TmpStr: String;
  p: PChar;
begin
  // This procedure is to convert ASCII characters into bin data
  // and save it in the file
  //
  // Check first if file exists
    if not FileExists(Edit1.Text) then
    begin
      messagebox (handle,'File does not exist' +
      #10#13'Please check file name','Error',0);
      exit;
    end;

    FileHandleA := FileOpen(Edit1.Text,fmOpenRead);
    if (FileHandleA = -1) then
      begin
        messagebox (handle,'FileOpen error','Error',0);
        exit;
      end;
     FileHandleB := FileCreate(Edit3.Text);
     if (FileHandleB = -1) then
       begin
         messagebox (handle,'FileCreate error','Error',0);
         exit;
       end;
       i := 0;
       j := 1;
     while (j < 2) do
       begin
         RetCode := FileRead(FileHandleA,CharBuf,1);
         if (RetCode < 1) then
           break;
         if ((CharBuf <> #10) and (CharBuf <> #13) and (CharBuf <> ' '))  then
           begin
             TmpStr := TmpStr + CharBuf;
             i := i + 1;
           end;
       end;
     if (i > 0) then
       begin
         BytesToWrite := i div 2;
         p := PChar(TmpStr);
         k := HexToBin(p,@OutBuf,i);
         Edit2.Text := IntToStr(k) + ' bytes converted to binary';
         FileWrite(FileHandleB,TmpStr,k);
       end;

    // At the end close both files
    FileClose(FileHandleA);
    FileClose(FileHandleB);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  BytesWritten: DWORD;
begin
  // Procedure to send data to the Xilinx board
  WriteFile(ComFile,OutBuf[1],BytesToWrite,BytesWritten,nil);
  Edit2.Text := IntToStr(BytesWritten) + ' bytes transmitted';

end;

procedure TForm1.Button4Click(Sender: TObject);
const
 RxBufSize = 8192;
 TxBufSize = 8192;
var
  Config: String;
  CommTimeouts: TCommTimeouts;
begin
  ComFile := CreateFile(PAnsiChar(Edit4.Text),
  GENERIC_READ or GENERIC_WRITE,
  0,
  nil,
  OPEN_EXISTING,
  FILE_ATTRIBUTE_NORMAL,
  0);
  if (ComFile = INVALID_HANDLE_VALUE) then
    begin
      messagebox (handle,'Failure to open COM port','Error',0);
      exit;
    end;
  if not SetupComm(ComFile,RxBufSize,TxBufSize) then
    begin
      messagebox (handle,'SetupComm() failed','Error',0);
      exit;
    end;

  if not GetCommState(ComFile,DCB) then
    begin
      messagebox (handle, 'GetCommState() failed','Error',0);
      exit;
    end;
  Config := 'baud=38400 parity=n data=8 stop=1';
  if not BuildCommDCB(@Config[1],DCB) then
    begin
      messagebox (handle, 'BuildCommDCB() failed','Error',0);
      exit;
    end;
  if not SetCommState(ComFile,DCB) then
    begin
      messagebox (handle, 'SetCommState() failed', 'Error',0);
      exit;
    end;
  with CommTimeouts do
    begin
      ReadIntervalTimeout := 0;
      ReadTotalTimeoutMultiplier := 0;
      ReadTotalTimeoutConstant := 200;
      WriteTotalTimeoutMultiplier := 0;
      WriteTotalTimeoutConstant := 200;
    end;
  if not SetCommTimeouts(ComFile, CommTimeouts) then
    begin
      messagebox (handle,'SetCommTimeouts() failed','Error',0);
      exit;
    end;
  Button3.Enabled := True;
  Button5.Enabled := True;
  Button6.Enabled := True;
  Button7.Enabled := True;
  Button9.Enabled := True;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
 BytesRead: DWORD;
 i,j,k: Integer;
 buf: array [0..4096] of Char;
 tmp_str: String;
begin    // Procedure to receive data from COM port
   if not ReadFile(ComFile,RxBuf,SizeOf(RxBuf),BytesRead,nil) then
     begin
       Edit2.Text := 'ReadFile failed';
       exit;
     end;
   if BytesRead <> 0 then    // If some data is read it needs to be displayed
     begin
      BinToHex(@RxBuf,buf,BytesRead);
//      Memo1.Lines.Text := lstr;
      Edit2.Text := IntToStr(BytesRead) + ' bytes read';
      j := 0;
      k := 0;
      tmp_str := '';
      if CheckBox1.Checked = True then
        Memo1.Lines.Clear;
      for i := 0 to ((BytesRead*2) - 1) do
        begin
          k := k + 1;
          if (k = 8) then
            begin
              k := 0;
              tmp_str := tmp_str + buf[i] + '   ';
            end
          else
            tmp_str := tmp_str + buf[i];
          j := j + 1;
          if (j = 64) then
            begin
              Memo1.Lines.Add(tmp_str);
              tmp_str := '';
              j := 0;
            end;
        end;
        Memo1.Lines.Add(tmp_str);
     end
   else
     begin
       Edit2.Text := 'Zero bytes read';
     end;

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Timer1.Enabled := True;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Timer1.Enabled := False;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then exit;
  Edit3.Text := OpenDialog1.FileName;

end;

procedure TForm1.Button9Click(Sender: TObject);
var
  FileHandleBin: Integer;
  i,j,RetCode: Integer;
  BytesWritten: DWORD;
  BinBuf: Byte;
begin
    FileHandleBin := FileOpen(Edit3.Text,fmOpenRead);
    if (FileHandleBin = -1) then
      begin
        messagebox (handle,'FileOpen error','Error',0);
        exit;
      end;
    j := 1;
    i := 1;
    while (j < 2) do
      begin
        RetCode := FileRead(FileHandleBin,BinBuf,1);
        if (RetCode < 1) then
          break;
        OutBuf[i] := BinBuf;
        i := i + 1;
      end;
    // Send data to the board
    WriteFile(ComFile,OutBuf[1],i,BytesWritten,nil);
    Edit2.Text := IntToStr(i) + ' bytes read from binary file ' + IntToStr(BytesWritten) + ' bytes transmitted';
    FileClose(FileHandleBin);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  if MessageDlg('Sure to quit?', mtConfirmation,
    [mbYes, mbNo], 0) = mrYes then
        Application.Terminate;

end;

end.
