//==================================================
//--------- Programmed by Alexey Grebennikov--------
//-------- alexey.grebennikov@bakerhughes.com-------
//==================================================
//		 
// General_purpose RAM module
//
module memory_tm (
  clk_i, we_i, data_i, adr_i,
  data_o
);
  input clk_i;            // Input clock
  input we_i;             // Write enable signal
  input [31:0] data_i;    // Input data
  input [9:0] adr_i;     // Input address
  output [31:0] data_o;   // Output data
  
  reg [31:0] data_o;
  reg [31:0] data [0:1023];


  always @ (negedge clk_i)       
    begin
      if (we_i)
        data[adr_i] <= data_i;
      data_o <= data[adr_i];
    end
endmodule