//==================================================
//--------- Programmed by Alexey Grebennikov--------
//-------- alexey.grebennikov@bakerhughes.com-------
//==================================================
//
// W Stage of the MIPS32-4kp execution core
//
module w_stage (
  clk_i, rst_i, rd_i, rda_i, wen_i,  
  rd_o, rda_o, wen_o
  );
  input clk_i;            // Input clock
  input rst_i;            // Input reset signal
  input [31:0] rd_i;      // Input destination register
  input [4:0] rda_i;      // Address of the input register
  input wen_i;            // Write enable signal from the A stage
  output [31:0] rd_o;     // Output register
  output [4:0] rda_o;     // Address of the output register
  output wen_o;           // Write enable signal for the register file
    
  reg [31:0] rd_o;
  reg [4:0] rda_o;
  reg wen_o;

  
  always @ (posedge clk_i)
    begin
      rd_o <= rd_i;
      rda_o <= rda_i;
      if (rda_i != 5'b00000)  // If not zero register
        wen_o <= 1'b1;
      else
        wen_o <= 1'b0;
    end
  
endmodule
